Subject: Re: [PATCH v2 0/5] Fix the racy split index problem

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Mon, 08 Oct 2018 16:54:51 +0200

On Fri, Sep 28 2018, Ævar Arnfjörð Bjarmason wrote:

> On Thu, Sep 27 2018, Ævar Arnfjörð Bjarmason wrote:
>
>> On Thu, Sep 27 2018, SZEDER Gábor wrote:
>>
>>> On Thu, Sep 27, 2018 at 03:53:24PM +0200, Ævar Arnfjörð Bjarmason wrote:
>>>>
>>>> On Thu, Sep 27 2018, SZEDER Gábor wrote:
>>>>
>>>> > This is the second attempt to fix the racy split index problem, which
>>>> > causes occasional failures in several random test scripts when run
>>>> > with 'GIT_TEST_SPLIT_INDEX=yes'.  The important details are in patches
>>>> > 1 and 5 (corresponding to v1's 3 and 5).
>>>>
>>>> Thanks. I'm running the same sorts of tests I noted in
>>>> https://public-inbox.org/git/[email-masked]/ on
>>>> this. The fix Jeff had that you noted in
>>>> https://public-inbox.org/git/20180906151439.GA8016@localhost/ is now in
>>>> "master".
>>>>
>>>> I take it your
>>>> https://github.com/szeder/git/commits/racy-split-index-fix is the same
>>>> as this submission?
>>>
>>> Yes.
>>>
>>>> Anyway, I'm testing that cherry-picked on top of the
>>>> latest master.
>>>>
>>>> Unfortunate that we couldn't get the isolated test you made in
>>>> https://public-inbox.org/git/20180907034942.GA10370@localhost/
>>>
>>> Nah, that's not an isolated test case, that's only a somewhat
>>> narrowed-down, but rather reliable reproduction recipe while I still
>>> had no idea what was going on :)
>>>
>>> The _real_ isolated test is the last test in t1701, that's what it
>>> eventually boiled down to.
>>
>> Thanks. I had ~400 runs of the tests I ran before and they were all
>> OK. Now trying also with t1701 (which I hadn't noticed was a new
>> test...).
>
> Ran that overnight with the same conditions as before. 2683 OK runs and
> 0 failures (and counting). So it seems like the combination of the two
> fixed the split index bugs.

I forgot I ad this running, and got up to 45482 OKs and 0 FAILs before
finally Ctrl+C-ing it now :)

>>>> but I
>>>> don't see how it could be added without some very liberal
>>>> getenv("GIT_TEST_blahblah"), so it's probably best to not add it,
>>>> particularly with the C rewrite of git-stash in-flight.
>>>>
>>>> I'll report back when I have enough test data to say how these patches
>>>> affect the intermittent test failures under GIT_TEST_SPLIT_INDEX=yes.